import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, continuedIndent, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { ifNotIn, completeFromList, ifIn } from '@codemirror/autocomplete';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,permit:18, forbid:20, principal:132, is:28, in:38, action:138, resource:146, when:56, unless:58, true:62, false:62, has:78, like:80, if:82, then:84, else:86, contains:88, containsAll:90, context:222};
const parser = LRParser.deserialize({
  version: 14,
  states: "5rQYQPOOOOQO'#C`'#C`OeQPO'#DjOOQO'#D`'#D`OYQPO'#C_OjQPO'#C_QYQPOOOOQO'#Dm'#DmOOQO'#D_'#D_OOQO'#Ca'#CaOoQPO,5:UOOQO-E7^-E7^OjQPO,58yOtQPO'#CgOyQPO,58yOOQO-E7]-E7]O!UQPO1G/pO!ZQPO1G.eOOQO'#Ci'#CiO!fQPO'#DoOOQO'#Ch'#ChO!tQPO'#DnO!yQPO,59ROOQO'#Dc'#DcO!ZQPO1G.eOOQO1G.e1G.eO#OQPO'#CwO#TQPO7+%[O#YQPO7+$POOQO7+$P7+$POOQO'#Cm'#CmO#eQPO,5:ZO#mQPO'#DxO#eQPO,5:ZOOQO,5:Z,5:ZO#rQPO,5:YOOQO1G.m1G.mOOQO-E7a-E7aO#wQPO,59cOOQO<<Hv<<HvOOQO<<Gk<<GkO$uQPO'#CkOOQO'#Da'#DaO$zQPO,5:eOOQO1G/u1G/uO%SQPO,5:dO%XQPO,5:fOOQO'#Cr'#CrO%aQPO'#DrOOQO'#Cq'#CqO%lQPO1G/tO%qQPO'#D|O%yQPO'#DtOOQO'#Cv'#CvOOQO'#D}'#D}OOQO'#EO'#EOO'cQQO1G.}O#wQPO'#E^O'jQPO'#EkOOQO'#D]'#D]OOQO'#D|'#D|O'rQPO'#EeOOQO,59V,59VOOQO-E7_-E7_OOQO1G0P1G0PO'wQPO1G0OOOQO1G0Q1G0QO#mQPO'#DyO(SQPO,5:^OOQO,5:^,5:^O([QPO7+%`O(aQPO,5;SOOQO,5:h,5:hO(iQPO'#DuO(qQPO,5:`O(vQPO'#EjO)OQPO,5;TOOQO'#C}'#C}OOQO'#DO'#DOOOQO'#DP'#DPOOQO'#DQ'#DQOOQO'#DR'#DRO#wQPO,5:mO#wQPO,5:mO#wQPO,5:mO#wQPO,5:mO#wQPO,5:mO#wQPO,5:wO)TQPO,5:yO#wQPO,5:|O)`QPO,5:zO#mQPO,5:{O)hQPO,5;OOOQO7+$i7+$iO)mQQO,5:xO)tQQO'#EmO)yQPO'#ElO*RQPO,5;VO*WQPO,5;PO#mQPO'#DtOOQO1G/x1G/xO*]QPO'#DvOOQO'#Cu'#CuOOQO<<Hz<<HzO#wQPO1G0nO*kQPO,5:aOOQO1G/z1G/zO*sQPO'#DeO+OQPO,5;UOOQO1G0o1G0oOOQO1G0X1G0XO,hQQO1G0XO,rQQO1G0XO.aQQO1G0XO.hQQO1G0XO.oQQO1G0cOOQO1G0e1G0eO.vQPO1G0lO.{QPO1G0mO/QQQO'#EcO/[QPO1G0hOOQO1G0f1G0fO/aQPO1G0gOOQO1G0j1G0jOOQO1G0d1G0dO*sQPO,5;XO'jQPO'#DfO/fQPO,5;WOOQO1G0q1G0qOOQO1G0k1G0kOOQO,5:b,5:bO/nQPO,5:bO/nQPO,5:bO/vQPO7+&YO/{QPO1G/{O#mQPO'#DbOOQO,5:P,5:POOQO-E7c-E7cOOQO7+%}7+%}O#wQPO7+&WO#wQPO7+&XO#wQPO'#DdO0TQPO,5:}OOQO7+&S7+&SO0]QSO7+&ROOQO1G0s1G0sOOQO,5:Q,5:QOOQO-E7d-E7dOOQO1G/|1G/|OOQO<<It<<ItOOQO-E7`-E7`O1vQPO,59|O2OQQO<<IrO2VQQO<<IsO2^QQO,5:OOOQO-E7b-E7bOOQO1G/h1G/hOOQOAN?^AN?^OOQOAN?_AN?_",
  stateData: "2h~O!]OSPOS~OXVOYVO!_PO~O!`XO~OU]O~OU`O~O!dbO~OljOmjO!QiO~OVkO~OljOmjO!QmO~O^pObnOcqOd!cX~OdsO~OWtO~OnvO~OWwO~OljOmjO!QxO~O!`yO!e|O~O!`yO~O!g!PO~OU!ZOV!WOg!UOn![Oo!WOp!WOy!_O!`yO!dbO!g!PO!k!VO!s!XO!t!XO#c!]O~O`!`O~OV!bO!`yO~O!`!cO~OV!dO!`yO~ObnOc!fOd!fX~Od!hO~OV!jO!`!iO~OV!WOo!WOp!WO!`yO~OU!{O^!}Ob!qOc!vOg!yOv!zOw!|Ox#OO!s!pO!v!oO!w!pO!x!qO!y!qO!z!qO!{!qO!|!qO!}!rO#O!sO~O!O#PO~P&XOV#RO!`#RO~Oz#UO~O`!`Od!liW!li~Og#VO!`yO~O!k!VO~OU#[O`!`O~OV#]O!`yO~Oh#^O~Od#_Oh#^X~Oh#aO~O|#iO}#jO!`#hO~OV#mO!`#mO~OV#oO~OW#pO~P&XO#b#qO~Od#rO!O#`X~O!O#tO~O{#uO~O^pObnOc#xOW!jX~Od#{Oh!ia~OV!WOo!WOp!WO~Od#_Oh#^a~O!v!oOU!ui^!uib!uic!uig!uiv!uiw!uix!ui!O!ui!x!ui!y!ui!z!ui!{!ui!|!ui!}!ui#O!uiW!uih!uid!ui~O!s!ui!w!ui~P+WO!s!pO!w!pO~P+WOb!qOc!vO!s!pO!v!oO!w!pO!x!qO!y!qO!z!qO!{!qO!|!qOU!ui^!uig!uiv!uiw!uix!ui!O!ui#O!uiW!uih!uid!ui~O!}!ui~P,|O!}!rO~P,|Oh$OO~P&XOU$PO~OU$QO~Od$ROW#VX~P&XOW$TO~O!`$UO~Od#rO!O#`a~O!`yO!o$YO~OW$ZO~Od#{Oh!ii~Od$ROW#Va~O`!`OU#Tq^#Tqb#Tqc#Tqg#Tqv#Tqw#Tqx#Tq!O#Tq!s#Tq!v#Tq!w#Tq!x#Tq!y#Tq!z#Tq!{#Tq!|#Tq!}#Tq#O#TqW#Tqh#Tqd#Tq~OV$bO!`yO~OW$cO~P&XOW$dO~P&XOW!Wad!Wa~P&XO",
  goto: ",g#bPPP#c#g#lPPPPP#o#u#xP$[P$}PPP%W%ZPP%m%p&SPPPPP&Y&g&s'O'YPPPPPPPPP#{P'c'i'p(q(w)R)X)_PPP)ePP)j)q)tPP)wP)z*^*bP*e*k*kP*t+k#{PP#{PPPPPPPPP#{#{#{#{#{#{,T#{#{#{#{#{#{,Z#{,^,aTWOUVQOSURYQQ^TRa[Re]Qc]k!^v!Z!t!u!v!w!x!y!{#[$P$Q$R!azopqv{}!O!T!U!Z!e!f!k!t!u!v!w!x!y!{!}#V#[#n#w#x#{$P$Q$R$]QocQ!e!QR#w#XR!SsQ!Qsk!^v!Z!t!u!v!w!x!y!{#[$P$Q$RR#Z!hj!^v!Z!t!u!v!w!x!y!{#[$P$Q$RR#X!hXg^ahlg!t!Y#Q#c#d#e#f#g#k$^$_$`e!u!Y#Q#d#e#f#g#k$^$_$`c!v!Y#Q#e#f#g#k$^$_$`a!w!Y#Q#f#g#k$^$_$`_!x!Y#Q#g#k$^$_$`QUOR_USSOURZSU{o!e#wQ}pU!Oq!f#xj!Tv!Z!t!u!v!w!x!y!{#[$P$Q$R^!a{}!O!T!k#n$]S!k!U#VQ#n!}R$]#{Q#z#]R$[#zQh^QlaTuhlQ$S#kR$a$SQ#`!mR#}#`Q#s#SR$X#sVROSUSTOUR[SRf]Rd]R!Rsj!^v!Z!t!u!v!w!x!y!{#[$P$Q$RR#W!fT!l!U#VR#Y!hQrcR#v#XQrcQ!g!QR#v#XQ!YvQ#Q!ZQ#b!tQ#c!uQ#d!vQ#e!wQ#f!xQ#g!yS#k!{#[Q$^$PQ$_$QR$`$Rj!^v!Z!t!u!v!w!x!y!{#[$P$Q$RQ!m!UQ#|#_R$V#qQ#l!{R#y#[R!n!UR#T![Q#S![R$W#r",
  nodeNames: "⚠ LineComment Program Policy At AnnotationKey ( String ) permit forbid Scope PrincipalConstraint Principal is Namespace :: CompareOp == in , ActionConstraint Action [ ] ResourceConstraint Resource Condition when unless { BooleanLiteral Int ArithOp ArithOp CompareOp LogicOp LogicOp . has like if then else contains containsAll } Context ;",
  maxTerm: 111,
  nodeProps: [
    ["isolate", 1,""]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 8,
  tokenData: ",h~RsXY#`YZ#`]^#`pq#`qr#qrs$Otu%lvw&axy&lyz&qz{&v{|&{|}'Q}!O'V!O!P'[!P!Q'a!Q![(O![!](W!]!^(e!^!_(j!_!`(w!`!a)S!a!b)a!b!c+r!c!}%l!}#O+w#P#Q+|#R#S%l#T#o%l#o#p,R#p#q,W#q#r,c$g;'S%l;'S;=`&Z<%lO%l~#eS!]~XY#`YZ#`]^#`pq#`V#vP!tP!_!`#yU$OO!|U~$RVOr$Ors$hs#O$O#O#P$m#P;'S$O;'S;=`%f<%lO$O~$mOV~~$pRO;'S$O;'S;=`$y;=`O$O~$|WOr$Ors$hs#O$O#O#P$m#P;'S$O;'S;=`%f;=`<%l$O<%lO$O~%iP;=`<%l$O~%qW!`~tu%l!Q![%l!c!}%l#R#S%l#T#o%l$g;'S%l;'S;=`&Z<%lO%l~&^P;=`<%l%l~&dPvw&g~&lO!}~~&qOU~~&vOW~~&{O!v~~'QO!w~~'VOd~~'[O!s~~'aOv~~'dP!P!Q'g~'lSP~OY'gZ;'S'g;'S;=`'x<%lO'g~'{P;=`<%l'g~(TPp~!Q![(OV(]P#bQ![!](`T(eO`T~(jO!Q~~(oP!x~!_!`(r~(wO!y~~(zP!_!`(}~)SOb~~)XP!{~!_!`)[~)aO!z~~)dQ#d#e)j#f#g*q~)mP#f#g)p~)sP#]#^)v~)yP#b#c)|~*PP#V#W*S~*VP#]#^*Y~*]P#d#e*`~*cP#T#U*f~*iP#`#a*l~*qO!e~~*tP#X#Y*w~*zP#g#h*}~+QP#c#d+T~+WP#i#j+Z~+^P#f#g+a~+dP#V#W+g~+jP#X#Y+m~+rO!o~~+wO!_~~+|Og~~,ROh~~,WOn~~,ZP#p#q,^~,cO#O~~,hO!O~",
  tokenizers: [0, 1, 2],
  topRules: {"Program":[0,2]},
  specialized: [{term: 62, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 0
});

let kwCompletion = (name) => ({ label: name, type: "keyword" });
"permit forbid when unless".split(" ").map(kwCompletion);
const cedarLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Scope: continuedIndent(),
                Condition: continuedIndent(),
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Effect: tags.definitionKeyword,
                "permit forbid": tags.definitionKeyword,
                "when unless": tags.keyword,
                "in is has contains containsAll": tags.operatorKeyword,
                "if then else": tags.controlKeyword,
                Identifier: tags.variableName,
                CompareOp: tags.compareOperator,
                BooleanLiteral: tags.bool,
                Principal: tags.variableName,
                Action: tags.variableName,
                Resource: tags.variableName,
                Context: tags.variableName,
                String: tags.string,
                Int: tags.integer,
                LineComment: tags.lineComment,
                At: tags.meta,
                AnnotationKey: tags.meta,
                "( )": tags.paren,
                "{ }": tags.brace,
                "[ ]": tags.squareBracket,
                ";": tags.separator,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: "//" },
    },
});
function cedar() {
    return new LanguageSupport(cedarLanguage, [
        cedarLanguage.data.of({
            autocomplete: ifNotIn(["String", "LineComment", "Scope", "Condition"], completeFromList([
                { label: "permit", type: "keyword" },
                { label: "forbid", type: "keyword" },
            ])),
        }),
        cedarLanguage.data.of({
            autocomplete: ifIn(["Scope"], completeFromList([{ label: "principal", type: "variable" }])),
        }),
        cedarLanguage.data.of({
            autocomplete: ifIn(["ActionConstraint"], completeFromList([{ label: "action", type: "variable" }])),
        }),
    ]);
}

export { cedar, cedarLanguage };
